// Author: Pete Kirkham
//
// quad store utils.
//
// string table.
// simpler than a general hash map, as it can only grow.
//
#ifndef _STRING_TABLE_H_
#define _STRING_TABLE_H_

#include <string>

#include "utils/core_utils.h"

class string_table_entry;

class string_table
{
public:
    string_table        () ;
    ~string_table       () ;

    bool            load    (const std::string& path) ;
    bool            save    (const std::string& path) ;

    unsigned int    put     (const std::string& string) ;
    const char*     get     (unsigned int id) ;

    void            dump    () ;

private:
    void    resize  (size_t allocate) ;

    std::string             _path;
    string_table_entry**    _entries;
    string_table_entry**    _recent;
    size_t                  _size;
    size_t                  _allocated;
    size_t                  _mask;
};

#endif // _STRING_TABLE_H_
